Index: gcc/config/rs6000/rs6000.opt
===================================================================
--- gcc/config/rs6000/rs6000.opt	(revision 251170)
+++ gcc/config/rs6000/rs6000.opt	(working copy)
@@ -196,13 +196,13 @@ mvsx
 Target Report Mask(VSX) Var(rs6000_isa_flags)
 Use vector/scalar (VSX) instructions.
 
+; This option existed in the past, but now is always on.
 mvsx-scalar-float
-Target Undocumented Report Var(TARGET_VSX_SCALAR_FLOAT) Init(1)
-; If -mpower8-vector, use VSX arithmetic instructions for SFmode (on by default)
+Target RejectNegative Undocumented Ignore
 
+; This option existed in the past, but now is always on.
 mvsx-scalar-double
-Target Undocumented Report Var(TARGET_VSX_SCALAR_DOUBLE) Init(1)
-; If -mvsx, use VSX arithmetic instructions for DFmode (on by default)
+Target RejectNegative Undocumented Ignore
 
 mvsx-align-128
 Target Undocumented Report Var(TARGET_VSX_ALIGN_128) Save
@@ -216,9 +216,9 @@ mefficient-unaligned-vsx
 Target Undocumented Report Mask(EFFICIENT_UNALIGNED_VSX) Var(rs6000_isa_flags)
 ; Consider unaligned VSX vector and fp accesses to be efficient
 
+; This option existed in the past, but it hadn't been used in awhile
 mallow-df-permute
-Target Undocumented Var(TARGET_ALLOW_DF_PERMUTE) Save
-; Allow permutation of DF/DI vectors
+Target RejectNegative Undocumented Ignore
 
 msched-groups
 Target Undocumented Report Var(TARGET_SCHED_GROUPS) Init(-1) Save
@@ -232,9 +232,9 @@ malign-branch-targets
 Target Undocumented Report Var(TARGET_ALIGN_BRANCH_TARGETS) Init(-1) Save
 ; Explicitly set rs6000_align_branch_targets
 
+; This option existed in the past, but now is always on.
 mvectorize-builtins
-Target Undocumented Report Var(TARGET_VECTORIZE_BUILTINS) Init(-1) Save
-; Explicitly control whether we vectorize the builtins or not.
+Target RejectNegative Undocumented Ignore
 
 mno-update
 Target Report RejectNegative Mask(NO_UPDATE) Var(rs6000_isa_flags)
Index: gcc/config/rs6000/rs6000.c
===================================================================
--- gcc/config/rs6000/rs6000.c	(revision 251170)
+++ gcc/config/rs6000/rs6000.c	(working copy)
@@ -3128,14 +3128,14 @@ rs6000_init_hard_regno_mode_ok (bool glo
 
   /* DFmode, see if we want to use the VSX unit.  Memory is handled
      differently, so don't set rs6000_vector_mem.  */
-  if (TARGET_VSX && TARGET_VSX_SCALAR_DOUBLE)
+  if (TARGET_VSX)
     {
       rs6000_vector_unit[DFmode] = VECTOR_VSX;
       rs6000_vector_align[DFmode] = 64;
     }
 
   /* SFmode, see if we want to use the VSX unit.  */
-  if (TARGET_P8_VECTOR && TARGET_VSX_SCALAR_FLOAT)
+  if (TARGET_P8_VECTOR)
     {
       rs6000_vector_unit[SFmode] = VECTOR_VSX;
       rs6000_vector_align[SFmode] = 32;
@@ -5909,8 +5909,7 @@ rs6000_builtin_vectorized_function (unsi
 	     GET_MODE_NAME (TYPE_MODE (type_in)));
 
   if (TREE_CODE (type_out) != VECTOR_TYPE
-      || TREE_CODE (type_in) != VECTOR_TYPE
-      || !TARGET_VECTORIZE_BUILTINS)
+      || TREE_CODE (type_in) != VECTOR_TYPE)
     return NULL_TREE;
 
   out_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -6041,8 +6040,7 @@ rs6000_builtin_md_vectorized_function (t
 	     GET_MODE_NAME (TYPE_MODE (type_in)));
 
   if (TREE_CODE (type_out) != VECTOR_TYPE
-      || TREE_CODE (type_in) != VECTOR_TYPE
-      || !TARGET_VECTORIZE_BUILTINS)
+      || TREE_CODE (type_in) != VECTOR_TYPE)
     return NULL_TREE;
 
   out_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -36253,9 +36251,6 @@ static struct rs6000_opt_var const rs600
   { "allow-movmisalign",
     offsetof (struct gcc_options, x_TARGET_ALLOW_MOVMISALIGN),
     offsetof (struct cl_target_option, x_TARGET_ALLOW_MOVMISALIGN), },
-  { "allow-df-permute",
-    offsetof (struct gcc_options, x_TARGET_ALLOW_DF_PERMUTE),
-    offsetof (struct cl_target_option, x_TARGET_ALLOW_DF_PERMUTE), },
   { "sched-groups",
     offsetof (struct gcc_options, x_TARGET_SCHED_GROUPS),
     offsetof (struct cl_target_option, x_TARGET_SCHED_GROUPS), },
@@ -36265,9 +36260,6 @@ static struct rs6000_opt_var const rs600
   { "align-branch-targets",
     offsetof (struct gcc_options, x_TARGET_ALIGN_BRANCH_TARGETS),
     offsetof (struct cl_target_option, x_TARGET_ALIGN_BRANCH_TARGETS), },
-  { "vectorize-builtins",
-    offsetof (struct gcc_options, x_TARGET_VECTORIZE_BUILTINS),
-    offsetof (struct cl_target_option, x_TARGET_VECTORIZE_BUILTINS), },
   { "tls-markers",
     offsetof (struct gcc_options, x_tls_markers),
     offsetof (struct cl_target_option, x_tls_markers), },